module.exports = {
  parser: "babel-eslint",
  rules: {
    "strict": 0,
    "no-extra-parens": 0,
    "consistent-return": 2,
    "dot-notation": 0,
    "eol-last": 2,
    "max-len": [ 1, 200, 4 ],
    "react/jsx-boolean-value": 2,
    "react/jsx-no-undef": 2,
    "react/jsx-sort-props": 0,
    "react/jsx-uses-react": 2,
    "react/jsx-uses-vars": 2,
    "react/no-did-mount-set-state": 2,
    "react/no-did-update-set-state": 2,
    "react/no-multi-comp": 0,
    "react/no-unknown-property": 0,
    "react/prop-types": 0,
    "react/react-in-jsx-scope": 2,
    "react/self-closing-comp": 2,
    "jsx-quotes": 2,
    "indent": [ 2, 2 ],
    "linebreak-style": [ 2, "unix" ],
    "quotes": [ 2, "double" ],
    "semi": [ 2, "never" ],
    "comma-dangle": [ 2, "always-multiline" ],
    "no-unexpected-multiline": [ 2 ],
    "space-before-function-paren": [ 1, "always" ],
    "space-before-blocks": [ 1, "always" ],
    "space-in-parens": [ 1, "always" ],
    "spaced-comment": [ 1 ],
    "space-unary-ops": [ 1 ],
    "keyword-spacing": [ 2 ],
    "computed-property-spacing": [ 2, "always" ],
    "key-spacing": [ 1, { mode: "minimum" } ],
    "block-spacing": [ 1, "always" ],
    "arrow-spacing": [ 1 ],
    "template-curly-spacing": [ 1, "always" ],
    "object-curly-spacing": [ 1, "always" ],
    "comma-spacing": [ 2 ],
    "array-bracket-spacing": [ 1, "always" ],
    "space-infix-ops": [ 1 ],
    "no-irregular-whitespace": [ 2 ],
    "no-multi-spaces": [ 2 ],
    "no-mixed-spaces-and-tabs": [ 2 ],
    "no-trailing-spaces": [ 2 ],
    "no-console": [ "warn", { allow: [ "warn", "error", "debug" ] } ],
  },
  env: {
    node: true,
    browser: true,
    es6: true,
  },
  extends: "eslint:recommended",
  parserOptions: {
    ecmaFeatures: { experimentalObjectRestSpread: true, jsx: true },
    sourceType: "module",
  },
  plugins: [
    "react",
  ],
  globals: {
    "document": true,
    "window": true,
    "browserHistory": true,
    "moment": true,
    "fromJS": true,
    "NODE_ENV": true,
  }
}
