"use strict";

/* eslint-env node*/
// require( "dotenv" ).config( { path: __dirname + "/.env" } )

var webpack = require("webpack");
var WebpackDevServer = require("webpack-dev-server");
var webpackConfig = require("./webpack.config");

console.log(webpackConfig);

var server = function server(config) {
  var webpackCfg = webpackConfig(config);
  return new WebpackDevServer(webpack(webpackCfg), {
    publicPath: webpackCfg.publicPath,
    hot: true,
    historyApiFallback: true,
    quiet: false,
    noInfo: false,
    stats: {
      errorDetails: true,
      assets: true,
      colors: true,
      version: false,
      hash: true,
      timings: true,
      modules: false,
      chunks: false,
      chunkModules: false
    }
  });
};

var defaultConfig = {
  env: {}
};

module.exports = {
  server: server,
  initialize: function initialize(config) {
    var _ref = config || defaultConfig,
        _ref$env = _ref.env,
        HOSTNAME = _ref$env.HOSTNAME,
        NODE_ENV = _ref$env.NODE_ENV;

    global.HOSTNAME = HOSTNAME || process.env.HOSTNAME;
    global.NODE_ENV = NODE_ENV || process.env.NODE_ENV;
    server(config).listen(3000, process.env.HOSTNAME, function (err) {
      if (err) {
        console.error(err);
      }
      console.error("Listening at " + process.env.HOSTNAME + ":3000");
    });
  }
};