#!/bin/node
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelCore = require("babel-core");

require("babel-polyfill");

var _recursiveReaddir = require("recursive-readdir");

var _recursiveReaddir2 = _interopRequireDefault(_recursiveReaddir);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _client = require("./exception/client");

var _client2 = _interopRequireDefault(_client);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var atNodeModules = function atNodeModules(file) {
  return _path2.default.resolve(__dirname + ("/../node_modules/" + file));
};

var babelOptions = {
  "presets": [atNodeModules("babel-preset-react"), atNodeModules("babel-preset-es2015"), atNodeModules("babel-preset-stage-0")],
  "plugins": [atNodeModules("babel-plugin-transform-decorators-legacy")]
};

var listFiles = function listFiles(path) {
  var filter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return new Promise(function (resolve, reject) {
    return (0, _recursiveReaddir2.default)(path, filter, function (error, files) {
      return error ? reject(error) : resolve(files);
    });
  });
};

var server = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var cwd, modulesDir, files;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            cwd = process.cwd();
            modulesDir = cwd + "/modules/";

            console.debug("__dirname: " + __dirname);
            console.debug("cwd: " + cwd);
            console.debug("modulesDir: " + modulesDir);
            _context.next = 7;
            return listFiles(modulesDir, ["!index.js"]);

          case 7:
            files = _context.sent;


            console.log(files);

            files.map(function (modulePath) {
              var relativePath = modulePath.replace(modulesDir, "");
              console.log(relativePath);
              var result = (0, _babelCore.transformFileSync)(modulePath, babelOptions).code;
              console.debug(result);
            });

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function server() {
    return _ref.apply(this, arguments);
  };
}();

var commands = {
  server: server,
  client: _client2.default
};

var init = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var command;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            console.log(process.argv);

            command = process.argv[2] || "server";


            commands[command]();

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function init() {
    return _ref2.apply(this, arguments);
  };
}();

init();

exports.default = init;