"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _ = require("../");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var parseValues = function parseValues(values, parse) {
  return parse.mapping.map(function (map) {
    return values[map.key];
  });
};

var generateCreatorQuery = function generateCreatorQuery(name, fields, record) {
  var parsedKeys = parseKeys(record, fields);
  return {
    parse: parsedKeys,
    query: "INSERT INTO " + name + "( " + (parsedKeys.keys.length > 0 ? parsedKeys.keys : "id") + " ) VALUES ( " + (parsedKeys.values.length > 0 ? parsedKeys.values : "default") + " ) RETURNING id"
  };
};

var parseKeys = function parseKeys(record, fields) {
  var result = { keys: [], values: [], mapping: [] };
  for (var key in record) {
    if (record.hasOwnProperty(key) && fields[key] !== undefined) {
      result.keys.push("\"" + key + "\"");
      result.values.push("$" + (result.values.length + 1));
      result.mapping.push({ key: key, value: "$" + result.values.length });
    }
  }
  return result;
};

var insertValues = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(fields, values, root) {
    var res, fieldKey, field, insertResult;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            res = {};
            _context.t0 = regeneratorRuntime.keys(fields);

          case 2:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 15;
              break;
            }

            fieldKey = _context.t1.value;

            if (!fields.hasOwnProperty(fieldKey)) {
              _context.next = 13;
              break;
            }

            field = fields[fieldKey];

            if (!field.insert) {
              _context.next = 13;
              break;
            }

            _context.next = 9;
            return field.insert(root, values[fieldKey], values);

          case 9:
            insertResult = _context.sent;

            if (!(insertResult === false)) {
              _context.next = 12;
              break;
            }

            return _context.abrupt("return", false);

          case 12:
            res = _extends({}, res, insertResult);

          case 13:
            _context.next = 2;
            break;

          case 15:
            return _context.abrupt("return", res);

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function insertValues(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = function (config) {
  return function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(root, _values) {
      var name, _fields, fields, values, key, value, insertRecord, record, fieldName, field, _generateCreatorQuery, query, parse, result;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              name = config.name, _fields = config.fields;
              fields = typeof _fields === "function" ? _fields() : _fields;
              values = {};

              for (key in _values) {
                if (_values.hasOwnProperty(key) && fields.hasOwnProperty(key) && !fields[key].proxy) {
                  value = _values[key];

                  if (value !== undefined) {
                    values[key] = value;
                  }
                }
              }
              _context2.next = 6;
              return insertValues(fields, values, root);

            case 6:
              insertRecord = _context2.sent;

              if (insertRecord) {
                _context2.next = 9;
                break;
              }

              return _context2.abrupt("return", false);

            case 9:
              record = _extends({}, values, insertRecord);

              for (fieldName in fields) {
                if (fields.hasOwnProperty(fieldName)) {
                  field = fields[fieldName];

                  if (field.dontInsert) {
                    delete record[fieldName];
                  }
                }
              }
              _generateCreatorQuery = generateCreatorQuery(name, fields, record), query = _generateCreatorQuery.query, parse = _generateCreatorQuery.parse;
              _context2.next = 14;
              return (0, _.psqlQuery)(query, parseValues(record, parse));

            case 14:
              result = _context2.sent;
              return _context2.abrupt("return", { id: result.rows[0].id, record: record });

            case 16:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x4, _x5) {
      return _ref2.apply(this, arguments);
    };
  }();
};