"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _graphql = require("graphql");

var _fetcher = require("./fetcher");

var _fetcher2 = _interopRequireDefault(_fetcher);

var _creator = require("./creator");

var _creator2 = _interopRequireDefault(_creator);

var _deleter = require("./deleter");

var _deleter2 = _interopRequireDefault(_deleter);

var _updater = require("./updater");

var _updater2 = _interopRequireDefault(_updater);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (config) {
  var name = config.name,
      friendlyName = config.friendlyName,
      title = config.title,
      description = config.description,
      fields = config.fields,
      flag = config.flag,
      beforeCreate = config.beforeCreate,
      afterCreate = config.afterCreate,
      afterUpdate = config.afterUpdate,
      stageType = config.stageType,
      mailTitle = config.mailTitle,
      explain = config.explain,
      onApprove = config.onApprove,
      onBulkApprove = config.onBulkApprove,
      onReject = config.onReject,
      onBulkReject = config.onBulkReject,
      filter = config.filter,
      afterDelete = config.afterDelete,
      beforeDelete = config.beforeDelete,
      resolve = config.resolve,
      flags = config.flags,
      args = config.args,
      fetchable = config.fetchable,
      onCancel = config.onCancel,
      refreshes = config.refreshes,
      synchronousCreate = config.synchronousCreate;

  return {
    name: name,
    friendlyName: friendlyName,
    title: title,
    mailTitle: mailTitle,
    args: args,
    explain: explain,
    description: description,
    flag: flag,
    beforeCreate: beforeCreate,
    afterCreate: afterCreate,
    afterUpdate: afterUpdate,
    beforeDelete: beforeDelete,
    afterDelete: afterDelete,
    stageType: stageType,
    fields: fields,
    resolve: resolve,
    onApprove: onApprove,
    onBulkApprove: onBulkApprove,
    onReject: onReject,
    onCancel: onCancel,
    onBulkReject: onBulkReject,
    filter: filter,
    flags: flags,
    refreshes: refreshes,
    synchronousCreate: synchronousCreate,
    type: new _graphql.GraphQLObjectType({
      name: name,
      description: description,
      fields: fields,
      resolve: resolve
    }),
    fetcher: (0, _fetcher2.default)(config),
    creator: (0, _creator2.default)(config),
    deleter: (0, _deleter2.default)(config),
    updater: (0, _updater2.default)(config),
    fetchable: fetchable
  };
};