"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _ = require("../");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var generateUpdaterQuery = function generateUpdaterQuery(name, fields, record, selector) {
  var parsedKeys = parseKeys(record, fields);
  return {
    values: parsedKeys.values,
    query: "UPDATE " + name + " SET " + parsedKeys.pairs.join(", ") + " WHERE id=" + parseInt(selector)
  };
};

var parseKeys = function parseKeys(record, fields) {
  var result = { pairs: [], values: [] };
  for (var key in record) {
    if (record.hasOwnProperty(key) && fields[key]) {
      result.values.push(record[key]);
      result.pairs.push("\"" + key + "\" = $" + result.values.length);
    }
  }
  return result;
};

var updateValues = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(fields, values, root, updatee) {
    var res, fieldKey, field;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            res = {};
            _context.t0 = regeneratorRuntime.keys(fields);

          case 2:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 16;
              break;
            }

            fieldKey = _context.t1.value;

            if (!fields.hasOwnProperty(fieldKey)) {
              _context.next = 14;
              break;
            }

            field = fields[fieldKey];

            if (!(field.update && values[fieldKey] !== undefined)) {
              _context.next = 14;
              break;
            }

            _context.t2 = _extends;
            _context.t3 = {};
            _context.t4 = res;
            _context.next = 12;
            return field.update(root, values[fieldKey], values, updatee);

          case 12:
            _context.t5 = _context.sent;
            res = (0, _context.t2)(_context.t3, _context.t4, _context.t5);

          case 14:
            _context.next = 2;
            break;

          case 16:
            return _context.abrupt("return", res);

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function updateValues(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = function (config) {
  return function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(root, values, selector, updatee) {
      var name, _fields, fields, record, queryConfig, result;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              name = config.name, _fields = config.fields;
              fields = typeof _fields === "function" ? _fields() : _fields;
              _context2.t0 = _extends;
              _context2.t1 = {};
              _context2.t2 = values;
              _context2.next = 7;
              return updateValues(fields, values, root, updatee);

            case 7:
              _context2.t3 = _context2.sent;
              record = (0, _context2.t0)(_context2.t1, _context2.t2, _context2.t3);
              queryConfig = generateUpdaterQuery(name, fields, record, selector);
              _context2.next = 12;
              return (0, _.psqlQuery)(queryConfig.query, queryConfig.values);

            case 12:
              result = _context2.sent;
              return _context2.abrupt("return", result.rowCount > 0);

            case 14:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x5, _x6, _x7, _x8) {
      return _ref2.apply(this, arguments);
    };
  }();
};