import React from "react"
import { render } from "react-dom"
import { AppContainer } from "react-hot-loader"

import Application from "app/Application"

moment.locale( "pt" )

if ( !window.headerIcon ) {
  let iconRel = document.createElement( "link" )
  iconRel.rel = "icon"
  iconRel.sizes = "128x128"
  document.head.appendChild( iconRel )

  window.headerIcon = true
}

const container = document.getElementById( "root" )

const renderApp = ( App ) => {

  const app = (
    <AppContainer>
      <App />
    </AppContainer>
  )

  render( app, container )
}

renderApp( Application )

if ( module.hot ) {
  module.hot.accept( () => {
    const NewApplication = require( "app/Application/" ).default
    renderApp( NewApplication )
  } )
}
