/* eslint-env node*/
// require( "dotenv" ).config( { path: __dirname + "/.env" } )

var webpack = require( "webpack" )
var WebpackDevServer = require( "webpack-dev-server" )
var webpackConfig = require( "./webpack.config" )

console.log( webpackConfig )

const server = config => {
  const webpackCfg = webpackConfig( config )
  return new WebpackDevServer( webpack( webpackCfg ), {
    publicPath: webpackCfg.publicPath,
    hot: true,
    historyApiFallback: true,
    quiet: false,
    noInfo: false,
    stats: {
      errorDetails: true,
      assets: true,
      colors: true,
      version: false,
      hash: true,
      timings: true,
      modules: false,
      chunks: false,
      chunkModules: false,
    },
  } )
}

const defaultConfig = {
  env: { },
}

module.exports = {
  server,
  initialize: ( config ) => {

    const { env: { HOSTNAME, NODE_ENV } } = config || defaultConfig

    global.HOSTNAME = HOSTNAME || process.env.HOSTNAME
    global.NODE_ENV = NODE_ENV || process.env.NODE_ENV
    server( config ).listen( 3000, process.env.HOSTNAME, err => {
      if ( err ) {
        console.error( err )
      }
      console.error( `Listening at ${ process.env.HOSTNAME }:3000` )
    } )
  },
}
