module.exports = {
  parser: "babel-eslint",
  rules: {
    "strict": 0,
    "dot-notation": 0,
    "eol-last": 2,
    "max-len": [1, 300, 4],
    "indent": [ 2, 2 ],
    "linebreak-style": [ 2, "unix" ],
    "quotes": [ 2, "double" ],
    "semi": [ 2, "never" ],
    "comma-dangle": [2, "always-multiline"],
    "no-extra-parens": 0,
    "dot-notation": 0,
    "eol-last": 2,
    "eqeqeq": [ 2, "smart" ],
    "jsx-quotes": 2,
    "no-unexpected-multiline": [ 2 ],
    "space-before-function-paren": [ 1, "always" ],
    "space-before-blocks": [ 1, "always" ],
    "space-in-parens": [ 1, "always" ],
    "spaced-comment": [ 1 ],
    "space-unary-ops": [ 1 ],
    "keyword-spacing": [ 2 ],
    "computed-property-spacing": [ 2, "always" ],
    "key-spacing": [ 1, { mode: "minimum" } ],
    "block-spacing": [ 1, "always" ],
    "arrow-spacing": [ 1 ],
    "template-curly-spacing": [ 1, "always" ],
    "object-curly-spacing": [ 1, "always" ],
    "comma-spacing": [ 2 ],
    "array-bracket-spacing": [ 1, "always" ],
    "space-infix-ops": [ 1 ],
    "no-irregular-whitespace": [ 2 ],
    "no-multi-spaces": [ 2 ],
    "no-mixed-spaces-and-tabs": [ 2 ],
    "no-trailing-spaces": [ 2 ],
    "no-console": ["warn", { allow: ["warn", "error", "debug"] }]
  },
  env: {
    node: true,
    browser: true,
    es6: true,
  },
  extends: "eslint:recommended",
  parserOptions: {
    ecmaFeatures: { experimentalObjectRestSpread: true },
    sourceType: "module",
  },
};
