import { GraphQLObjectType } from "graphql"
import generateFetcher from "./fetcher"
import generateCreator from "./creator"
import generateDeleter from "./deleter"
import generateUpdater from "./updater"

export default config => {
  const {
    name, friendlyName, title, description,
    fields, flag, beforeCreate,
    afterCreate, afterUpdate, stageType, mailTitle,
    explain, onApprove, onBulkApprove,
    onReject, onBulkReject,
    filter, afterDelete, beforeDelete,
    resolve, flags, args, fetchable, onCancel,
    refreshes, synchronousCreate,
  } = config
  return {
    name,
    friendlyName,
    title,
    mailTitle,
    args,
    explain,
    description,
    flag,
    beforeCreate,
    afterCreate,
    afterUpdate,
    beforeDelete,
    afterDelete,
    stageType,
    fields,
    resolve,
    onApprove,
    onBulkApprove,
    onReject,
    onCancel,
    onBulkReject,
    filter,
    flags,
    refreshes,
    synchronousCreate,
    type: new GraphQLObjectType( {
      name,
      description,
      fields,
      resolve,
    } ),
    fetcher: generateFetcher( config ),
    creator: generateCreator( config ),
    deleter: generateDeleter( config ),
    updater: generateUpdater( config ),
    fetchable,
  }
}
